LPARAMETERS lcFile, llVisible
** Funkcija f_Excel_gen
** Upildo nurodyt Excel failo ablon
** Excel ablone pildomos vietos (VFP komandos, PRIVATE kintamieji ar aktyvaus kursoriaus laukai) nurodomos tarp enkl: <<KEICIAMAS_TEKSTAS>>
** Parametrai:
** 1. Pildomo Excel failo vardas
** 2. Ar atverti Excel dokument informacijos pildymo metu (.T. arba .F., pagal nutyljim .F.)
** Grina ar buvo pildymo klaid
** Pavyzdys: f_Excel_gen("c:\dokumentai\Sutartis_140925.xlsx")

LOCAL lal
m.lal=ALIAS()

IF TYPE("m.lcFile")#"C" OR !FILE(m.lcFile)
	l_window("Nurodytas MS Excel ablono failas nerastas!")
	RETURN .F.
ENDIF

IF !x_Excel_test()
	RETURN .F.
ENDIF

PRIVATE oDocument, pcExcelAlias
LOCAL loExcel, lcCommand, lcRez, llKlaida, _err
m.pcExcelAlias=m.lal
m._err=.F.
m.llKlaida=.F.
m.oDocument = GetObject(m.lcFile)
m.loExcel=m.oDocument.Application

m.ash=m.oDocument.ActiveSheet
m.loExcel.visible=m.llVisible

m.oDocument.Application.Windows(1).Visible=.T.
*m.oDocument.Application.Windows(m.oDocument.Application.Windows.Count).Visible=.T. && Niuansas
IF !EMPTY(m.lal) AND USED(m.lal)
	SELECT(m.lal)
ENDIF
IF !x_Excel_gen_exec(m.oDocument)
	m.llKlaida=.T.
ENDIF

*IF TYPE("m.loExcel.Version")="C" AND VAL(m.loExcel.Version)<14
	m.ash.Activate()
	m.oDocument.Save()
	m.oDocument.Close()
	*TRY
	*	m.loExcel.Quit()
	*CATCH TO m._err
	*ENDTRY
*ENDIF

RELEASE oDocument
RELEASE loExcel

RETURN !m.llKlaida


*********** Patikriname ar instaliuotas Excel'as ***********
PROCEDURE x_Excel_test
LOCAL oExcel, lExcel, _err
m._err=.F.
m.lExcel=.F.
m.oExcel=.F.
TRY
	m.oExcel=CREATEOBJECT("Excel.Application")
	IF TYPE("m.oExcel")="O"
		m.lExcel=.T.
		m.oExcel.Quit()
	ENDIF
CATCH TO m._err
ENDTRY
IF !m.lExcel
	l_window("Nediegta arba nepasiekiama MS Excel programa!")
	RETURN .F.
ENDIF
RELEASE oExcel, lExcel
RETURN .T.
ENDPROC


*********** Excel'inio failo upildymas ***********
PROCEDURE x_Excel_gen_exec
LPARAMETERS oDocument
PRIVATE _klaida
_klaida=.F.
LOCAL llKlaida, lcRez, lcCommand, rr, _err
m.llKlaida=.F.
m._err=.F.

m.ln=m.oDocument.Sheets.Count
m.i=1
FOR m.i=1 TO m.ln
	m.loRange=m.oDocument.Sheets[m.i]
	DO WHILE (.T.)
		m.rr=m.loRange.Cells.Find("<<*>>")
		IF ISNULL(m.rr)
			EXIT
		ENDIF
		m.lcCommand=x_Excel_text_replace(m.rr.Text)
		IF !EMPTY(_klaida)
			m.llKlaida=.T.
			EXIT
		ENDIF
		m.rr.Replace(m.rr.Text,m.lcCommand)
	ENDDO
ENDFOR
RETURN !m.llKlaida
ENDPROC

**** 
PROCEDURE x_Excel_text_replace
LPARAMETERS lcText, lcStart, lcEnd, llSilent, llHTML

IF TYPE("m.lcText")#"C"
	RETURN ""
ENDIF
IF EMPTY(NVL(m.lcText,""))
	RETURN m.lcText
ENDIF

IF TYPE("m.lcStart")#"C" OR EMPTY(NVL(m.lcStart,""))
	m.lcStart="<<"
	IF !EMPTY(m.llHTML)
		m.lcStart="&lt;&lt;"
	ENDIF
ENDIF

IF TYPE("m.lcEnd")#"C" OR EMPTY(NVL(m.lcEnd,""))
	m.lcEnd=">>"
	IF !EMPTY(m.llHTML)
		m.lcEnd="&gt;&gt;"
	ENDIF
ENDIF

LOCAL lcRez, lcCommand, _err, x, y
m._err=.F.
m.x=ATC(m.lcStart,m.lcText)
DO WHILE m.x>0
	m.y=ATC(m.lcEnd,SUBSTR(m.lcText,m.x+LEN(m.lcStart)))
	IF m.y=0
		RETURN m.lcText && EXIT
	ENDIF
	
	m.lcCommand=SUBSTR(m.lcText,m.x+LEN(m.lcStart),m.y-1)
	m.lcCommand=CHRTRAN(m.lcCommand,[],["""])
	m.lcCommand=CHRTRAN(m.lcCommand,[],['])
	TRY
		m.lcRez=&lcCommand
	CATCH TO m._err
	ENDTRY
	IF TYPE("m._err")="O" AND !ISNULL(m._err) && Klaida
		=l_window(l_tek([Klaida: ])+LEFT(ALLTRIM(m._err.message),150),"P")
		IF EMPTY(m.llSilent)
			=f_info(l_tek([Klaida: ])+LEFT(ALLTRIM(m._err.message),250)+CHR(13)+[Komanda: ]+LEFT(lcCommand,2000),.T.)
		ENDIF
		_klaida=l_tek([Klaida: ])+LEFT(ALLTRIM(m._err.message),150)
		RETURN m.lcText && EXIT
	ENDIF
	DO CASE
		CASE TYPE("m.lcRez")="C" OR TYPE("m.lcRez")="M"
			m.lcRez=m.lcRez
		CASE TYPE("m.lcRez")="N"
			m.lcRez=ALLTRIM(STR(m.lcRez,10,2))
		CASE TYPE("m.lcRez")="L"
			m.lcRez=IIF(m.lcRez,".T.",".F.")
		CASE TYPE("m.lcRez")="D"
			m.lcRez=DTOC(m.lcRez)
		CASE TYPE("m.lcRez")="T"
			m.lcRez=TTOC(m.lcRez)
		OTHERWISE
			m.lcRez=""
	ENDCASE
	
	IF !EMPTY(m.llHTML)
		m.lcRez=xml_encode(m.lcRez)
	ENDIF
	m.lcText=SUBSTR(m.lcText,1,m.x-1)+m.lcRez+SUBSTR(m.lcText,m.x+LEN(m.lcStart)+m.y+LEN(m.lcEnd)-1)
	
	m.x=ATC(m.lcStart,m.lcText)
ENDDO
RETURN m.lcText

ENDPROC
